# -*- encoding: utf-8n -*-
# Copyright (c) 2010, Takaya Kakizaki(kacky)
# All rights reserved.
#
#  ソースコード形式かバイナリ形式か、変更するかしないかを問わず、以下の条件を満たす場合に限り、再頒布および使用が許可されます。 
#
#  ・ソースコードを再頒布する場合、上記の著作権表示、本条件一覧、および下記免責条項を含めること。 
#
#  ・バイナリ形式で再頒布する場合、頒布物に付属のドキュメント等の資料に、上記の著作権表示、本条件一覧、および下記免責条項を含めること。 
#
#  ・書面による特別の許可なしに、本ソフトウェアから派生した製品の宣伝または販売促進に、オープン麻雀の名前またはコントリビューターの名前を使用してはならない。
#
#
#  本ソフトウェアは、著作権者およびコントリビューターによって「現状のまま」提供されており、明示黙示を問わず、
#  商業的な使用可能性、および特定の目的に対する適合性に関する暗黙の保証も含め、またそれに限定されない、いかなる保証もありません。
#  著作権者もコントリビューターも、事由のいかんを問わず、 損害発生の原因いかんを問わず、かつ責任の根拠が契約であるか厳格責任であるか
#  （過失その他の）不法行為であるかを問わず、仮にそのような損害が発生する可能性を知らされていたとしても、本ソフトウェアの使用によって発生した
#  （代替品または代用サービスの調達、使用の喪失、データの喪失、利益の喪失、業務の中断も含め、またそれに限定されない）
#  直接損害、間接損害、偶発的な損害、特別損害、懲罰的損害、または結果損害について、一切責任を負わないものとします。 
# サーバー側テストプログラム
$LOAD_PATH << File.dirname(__FILE__)
$localserver = 0

require "mahjongserver"
require "webrick"
PROFILE_OUT = false # プロファイルを出力

if PROFILE_OUT
  require "profiler"
end

SENDLOSTRATE = 0    # 送信パケットをロストする確率
RECVLOSTRATE = 0    # 受信パケットをロストする確率

def webrick(srv)
  srv.instance_eval do |server|
    [:INT, :TERM].each do |signal|
      Signal.trap(signal) {
        if PROFILE_OUT
          Profiler__.print_profile(STDERR)
        end
        shutdown
      }
    end
    start
  end
end



srv = WEBrick::HTTPServer.new({:DocumentRoot => '/home/kakizaki/openmahjong/',:BindAddress => '0.0.0.0',:Port => 10080})

$performdump = STDERR

if PROFILE_OUT
  Profiler__.start_profile
end

srv.mount_proc('/index.rb') { |req,res|
  if rand() >= SENDLOSTRATE
    mes = sendRequest(req.body)
  else
    mes = ""
  end
  
  if rand() < RECVLOSTRATE
    mes = ""
  end
  
  res['Content-Type'] = "application/xml"
  res['Content-Length'] = mes.size
  res.body = mes
  res.keep_alive = false
}

webrick(srv)
